/****************************************************************************
Date: 1/23/97
File: loctypes.h
Description:	Local Type definitions
	Defines standard types to aid in compatibility across multiple
	compilers. Supports Microsoft and Borland
*****************************************************************************/
#ifndef LOCTYPES_H
#define LOCTYPES_H

/* Basic Types */
typedef void		VOID;

typedef	char		CHAR;
typedef	unsigned char	UCHAR;

typedef short		SHORT;
typedef unsigned short 	USHORT;

typedef int		INT;
typedef unsigned int 	UINT;

typedef long		LONG;
typedef unsigned long	ULONG;

typedef float		FLOAT;
typedef double		DOUBLE;
typedef long double	LONGDOUBLE;

enum BOOL {
	BOOL_FALSE = 0,
	BOOL_TRUE = !BOOL_FALSE
};
	
/* x86 definitions */
typedef UCHAR	BYTE;
typedef USHORT	WORD;

#define GET_DSEG()		getdseg()
#define GET_OFF(address)	((INT) address)


/* Special types for DOS */
#define FAR	__far
#define NEAR	__near
#define	HUGEPTR	__huge*		/* note "HUGE" used in math.h! */
typedef UINT	IOADDRESS;	/* for inp(), outp() i/o */

/****** Special types for DOS interrupt handlers ******/

/* saved registers on the stack */
typedef UINT	INTREG;
#define INTREGS INTREG INTREG_ES, INTREG INTREG_DS,\
		INTREG INTREG_DI, INTREG INTREG_SI,\
		INTREG INTREG_BP, INTREG INTREG_SP,\
		INTREG INTREG_BX, INTREG INTREG_DX,\
		INTREG INTREG_CX, INTREG INTREG_AX,\
		INTREG INTREG_IP, INTREG INTREG_CS,\
		INTREG INTREG_FLAGS


#define INTERRUPT  __interrupt __far

#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

#ifdef __BORLANDC__
typedef void INTERRUPT  (*INTHANDLER)(__CPPARGS);
#else
typedef void (INTERRUPT* INTHANDLER)(VOID);
#endif

#endif
