/****************************************************************************
Date: 4/26/98
File: mycout.hpp
Description:	Local ostream class
	This class implements part of the C++ output stream object
	(i.e."cout") and provides a simple output stream to the console.

	This class uses only stdio.h so it is compatible with the
	fast floating point math library (which iostream.h is not)

	public: 
		MYCOUT()
		endl;
		operator << {INT, UINT, CHAR*}
	
*****************************************************************************/
#ifndef MYCOUT_HPP
#define MYCOUT_HPP

#include "loctypes.h"
#include <stdio.h>

class MYCOUT {
public:
	MYCOUT() {}

	MYCOUT& operator<<(MYCOUT& (*f)(MYCOUT&)) {
		(*f)(*this);
		return *this;
	}
	
	MYCOUT& operator<<(CHAR c) {
		printf("%c", c);
		return *this;
	}

	MYCOUT& operator<<(INT i) {
		printf("%d", i);
		return *this;
	}

	MYCOUT& operator<<(UINT u) {
		printf("%u", u);
		return *this;
	}

	MYCOUT& operator<<(DOUBLE d) {
		printf("%e", d);
		return *this;
	}

	MYCOUT& operator<<(const CHAR* pszString) {
		printf("%s", pszString);
		return *this;
	}
};

extern MYCOUT cout;

inline MYCOUT& endl(MYCOUT& Cout) {
	Cout << '\n';
	fflush(stdout);
	return Cout;
}

#endif
