/****************************************************************************
Date: 10/22/95 
File: ppdrv.hpp
Description:
	Parallel Port Driver


*****************************************************************************/
#ifndef PPDRV_HPP
#define PPDRV_HPP

#include <stddef.h>
#include "loctypes.h"
#include "dospc.h"	// Non-ANSI DOS Functions
#include "inttimer.hpp"	// interval timer

const UINT PPORTBIOSSEGMENT = 0x0040;
const UINT PPORTBIOSOFFSET  = 0x08;
const UINT PPORTDRIVER_MAXPORT  = 4;

typedef BYTE PPORTBITS;

class PPORTDRIVER {
private:
	IOADDRESS	Address;
	PPORTBITS	BitImage;
	IOADDRESS	GetAddress(USHORT unPortNumber);

public:
	PPORTDRIVER();
	BOOL	Open(USHORT unPortNumber, IOADDRESS Address = 0);
	PPORTBITS ReadStatus();
	VOID	Write(PPORTBITS);
	VOID	SetBits(PPORTBITS Bits);
	VOID	ClearBits(PPORTBITS Bits);
	BOOL	CheckStatus(PPORTBITS Bits);
	VOID	Close();
};

#endif // ppdrv.hpp
