// TEST 6 of FT-847
// file: test847.cpp
// Version 1.3
// Date: 11/11/00

#include <iostream.h>
#include "loctypes.h"
#include "comdrv.hpp"
#include "dospc.h"

static VOID DisplayList() {
	cout << endl;
	cout << "0. Turn CAT ON" << endl;
	cout << "1. Turn CAT OFF" << endl;
	cout << "2. Turn SAT MODE ON" << endl;
	cout << "3. Turn SAT MODE OFF" << endl;
	cout << "4. Set TX VFO to 145.678 MHz" << endl;
	cout << "5. Set RX VFO to 432.109 MHz" << endl;
	cout << "6. Set MAIN VFO to 144.444 MHz" << endl;
	cout << "7. Set Repeater offset to 100KHz" << endl;
	cout << "8. Set Repeater shift to +" << endl;
/*****
	cout << "9. Read Main VFO (not sat mode)" << endl;
	cout << "10. Read Rx VFO (sat mode)" << endl;
	cout << "11. Read Tx Status " << endl;

	//cout << "9. Turn on CAT and SAT mode" << endl;
	//cout << "9. Special Test" << endl;
*****/
	cout << "9. Exit test program" << endl;
	cout << "Please enter a test number:";
}

struct COMMAND {
	UCHAR	Msg[5];
};

const UINT MAXTESTNUMBER = 9;

const COMMAND Command[MAXTESTNUMBER] = {
	{ 0x00, 0x00, 0x00, 0x00, 0x00 }, // CAT ON
	{ 0x00, 0x00, 0x00, 0x00, 0x80 }, // CAT OFF
	{ 0x00, 0x00, 0x00, 0x00, 0x4e }, // SAT MODE ON
	{ 0x00, 0x00, 0x00, 0x00, 0x8e }, // SAT MODE OFF
	{ 0x14, 0x56, 0x78, 0x00, 0x21 }, // TX VFO = 145.678
	{ 0x43, 0x21, 0x09, 0x00, 0x11 }, // RX VFO = 432.109
	{ 0x14, 0x44, 0x44, 0x00, 0x01 },  // MAIN VFO = 144.444
	{ 0x00, 0x01, 0x00, 0x00, 0xf9 },  // rptr offset = 100KHz
	{ 0x49, 0x00, 0x00, 0x00, 0x09 },  // Plus shift

/*
	{ 0x12, 0x34, 0x56, 0x78, 0x03 },  // Read MAIN VFO
	{ 0x00, 0x00, 0x00, 0x00, 0x13 },  // Read sat vfo
	{ 0x00, 0x00, 0x00, 0x00, 0xF7 }   // Read Tx Status
*/

};

main() {
	cout << "FT-847 Test program 4" << endl;
	cout << "Runs on COM 2 at 4800 bps" << endl;
	//cout << "This tests satellite mode" << endl;

	// Set up COM port
	COMDRV	Com;
	Com.Open(2,	// COM port
		 4800,	// bps
		 8,	// bits
		 UARTPARITY_NONE, // pretty clear!
		 2);	// stop bits
		
	// Loop until user quits
	UINT	unTestNumber;
	BOOL	eDone = BOOL_FALSE;

	do {
		DisplayList();
		cin >> unTestNumber;
		if (unTestNumber > MAXTESTNUMBER) {
			eDone = BOOL_TRUE;
		}
/********
		else if ((unTestNumber == 7) ||
			 (unTestNumber == 8)) { // read vfo

			UCHAR Buffer[10] = { 0 };
			Com.Write(&Command[unTestNumber], 5);	// Send read
			sleep(2);
			INT nCount = Com.Read(&Buffer, 10);

			for (INT i=0; i<nCount ; i++) {
				cout << hex << (UINT) Buffer[i] << ", ";
			}
			cout << dec << endl;
			// 1st 4 bytes in buffer are freq in "Yaesu BCD"
			// byte 0 = 100MHz and 10MHz
			// byte 1 = 1MHz and 100KHz
			// byte 2 = 10KHz and 1 KHz
			// byte 3 = 100Hz and 10Hz

			LONG lFreq = 0;		// frequency accumulator
			LONG lMultiplier = 100000000L;	// (i.e. 100MHz)

			for ( INT i = 0; i < 4; i++) {

				// Process upper digit
				lFreq += ((Buffer[i] & 0xf0) >> 4) *
								lMultiplier;
				lMultiplier /= 10;

				// Process lower digit
				lFreq += (Buffer[i] & 0x0f) * lMultiplier;
				lMultiplier /= 10;
			}

			cout << "Rx Frequency = " << lFreq << endl;

			// Next, get modulation and convert
			// to RADIO::MODULATION enum type
			// byte 4 = modulation code
			// 00=LSB, 01=USB, 02=CW, 03=CW-R, 04=AM, 08=FM, 
			// 82=CW(N), 83=CW(N)-R, 84=AM(N), 88=FM(N)

			cout << "Rx Modulation = " << ((UINT) Buffer[4]);
			cout << endl;
		}
		else if (unTestNumber == 9) { // SPECIAL test
			Com.Write(&Command[unTestNumber], 5); // get TX status

		else if (unTestNumber == 9) { // SPECIAL test
			Com.Write(&Command[0], 5);	// Send CAT ON
			Com.Write(&Command[2], 5);	// Send SAT MODE ON
UCHAR aSetRxMode[] = { 0x02, 0x00, 0x00, 0x00, 0x17 };
UCHAR aSetRxVFO[] =  { 0x02, 0x85, 0x25, 0x00, 0x11 };
UCHAR aSetTxMode[] = { 0x02, 0x00, 0x00, 0x00, 0x27 };
UCHAR aSetTxVFO[] =  { 0x14, 0x59, 0x50, 0x00, 0x21 };
UCHAR aGetRxVFO[] =  { 0x00, 0x00, 0x00, 0x00, 0x13 };  // Read sat vfo

			Com.Write(aSetRxMode, 5);
			Com.Write(aSetRxVFO, 5);
			Com.Write(aSetTxMode, 5);
			Com.Write(aSetTxVFO, 5);

			Com.Write(aGetRxVFO, 5);

			UCHAR Buffer[10] = { 0 };
			cout << "RESULT: ";
			sleep(2);
			INT nCount = Com.Read(&Buffer, 10);

			for (INT i=0; i<nCount ; i++) {
				cout << hex << (UINT) Buffer[i] << ", ";
			}
			cout << dec << endl;

			Com.Write(&Command[3], 5);	// Send SAT MODE OFF
			Com.Write(&Command[1], 5);	// Send CAT OFF
		}
******/
		else {
			// Regular test, Send command
			Com.Write(&Command[unTestNumber], 5);
		}
	} while (!eDone);

	Com.Close();

	cout << "Thanks for running test 3!" << endl;
	cout << "73, Tony AA2TX" << endl;
	return 0;
}
