// Date: 9/5/99

#include <stdlib.h>
#include <dos.h>
#include <iostream.h>
#include "loctypes.h"
#include "comdrv.hpp"
#include "dospc.h"


//***** DOS Timer
static volatile ULONG ulTicks;
static INTHANDLER pfnDosTimer;

VOID INTERRUPT DOSTimerISR(VOID) {

	// Update Timer
	ulTicks++;

        // let DOS timer handler run
        _chain_intr(pfnDosTimer);
}

main() {
	cout << "***** COM port bit rate test program *****" << endl;

	UINT unCOMPort = 1;
	UINT unIRQ = 0;
	UINT unBitRate;

	cout << "Please enter COM port: ";
	cin >> unCOMPort;

	cout << "Please enter IRQ or 0 for default: ";
	cin >> unIRQ;
	
	cout << "Please enter desired bit rate: "; 
	cin >> unBitRate;

	cout << "Opening COM " << unCOMPort << " at " << unBitRate;
	cout << " bps" << endl;

	// Set up COM port
	COMDRV	Com;
	BOOL eOpen = Com.Open(unCOMPort,	// COM port
		 		unBitRate, // bps
		 		8,	// bits
		 		UARTPARITY_NONE, // pretty clear!
		 		2,	// stop bits
		 		unIRQ); // IRQ

	if (eOpen == BOOL_FALSE) {
		cout << "Error - COM port failed to open" << endl;
		return 0;
	}

	// Hook DOS Timer Interrupt
	disable();
        pfnDosTimer = getvect(0x1c);
	setvect(0x1c, DOSTimerISR);
	enable();

	cout << "This test takes 11 seconds..." << endl;
	
	UINT unCount = 0;
	ulTicks = 0;
	while (ulTicks == 0) {}	// sync to dos clock
	Com.Putc(unCount);
	Com.Putc(unCount);
	do {
		if (Com.Getc() != COMDRV_EOF) {
			unCount++;
			Com.Putc(unCount);
		}
	} while (ulTicks < 201);

	cout << "Detected bit rate = " << unCount << " bps" << endl;

	Com.Close();

	disable();
	setvect(0x1c, pfnDosTimer);
	enable();

	return 0;
}
